## wraplinux 1.7

=== Makefile ===
-include		MCONFIG
PERL			?= perl

RELOC_OBJS		= $(patsubst %.c,%.o,$(wildcard reloc/*.c)) \
			  $(patsubst %.S,%.o,$(wildcard reloc/*.S))

HIGHMOVE_OBJS		= $(patsubst %.c,%.o,$(wildcard highmove/*.c)) \
			  $(patsubst %.S,%.o,$(wildcard highmove/*.S))

all: wraplinux

reloc/%.o: reloc/%.c
	$(CC_FOR_TARGET) $(CFLAGS_FOR_TARGET) -c -o $@ $<

reloc/%.o: reloc/%.S
	$(CC_FOR_TARGET) $(CFLAGS_FOR_TARGET) -c -D__ASSEMBLY__ -o $@ $<

highmove/%.o: highmove/%.c
	$(CC_FOR_TARGET) $(CFLAGS_FOR_TARGET) -c -o $@ $<

highmove/%.o: highmove/%.S
	$(CC_FOR_TARGET) $(CFLAGS_FOR_TARGET) -c -D__ASSEMBLY__ -o $@ $<

%.o: %.S
	$(CC) $(CFLAGS) -c -o $@ $<

%.s: %.S
	$(CC) $(CFLAGS) -E -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

%.s: %.c
	$(CC) $(CFLAGS) -S -o $@ $<

%.i: %.c
	$(CC) $(CFLAGS) -E -o $@ $<

reloc/reloc.bin: reloc/reloc.elf
	$(OBJCOPY_FOR_TARGET) -O binary $< $@

reloc/reloc.elf: $(RELOC_OBJS) reloc/reloc.ld
	$(LD_FOR_TARGET) $(LDFLAGS_FOR_TARGET) -T reloc/reloc.ld \
		-o $@ $(RELOC_OBJS)

reloc.o: reloc.S reloc/reloc.bin

highmove/highmove.bin: highmove/highmove.elf
	$(OBJCOPY_FOR_TARGET) -O binary $< $@

highmove/highmove.elf: $(HIGHMOVE_OBJS) reloc/reloc.ld
	$(LD_FOR_TARGET) $(LDFLAGS_FOR_TARGET) -T reloc/reloc.ld \
		-o $@ $(HIGHMOVE_OBJS)

highmove.o: highmove.S highmove/highmove.bin

wraplinux: main.o linux.o reloc.o highmove.o elf.o nbi.o segment.o mapfile.o \
	   cwrite.o xmalloc.o
	$(CC) $(LDFLAGS) -o $@ $^

#
# Install
#
install: all
	$(MKDIR_P) $(INSTALLROOT)$(bindir)
	$(INSTALL_PROGRAM) wraplinux $(INSTALLROOT)$(bindir)
	$(MKDIR_P) $(INSTALLROOT)$(mandir)/man1
	$(INSTALL_DATA) wraplinux.1 $(INSTALLROOT)$(mandir)/man1

#
# Cleanup
#
clean:
	rm -f wraplinux *.o *.s *.i
	rm -f reloc/*.o reloc/*.bin reloc/*.elf
	rm -f highmove/*.o highmove/*.bin highmove/*.elf

cleaner: clean
	rm -rf MCONFIG config.h *.cache config.status config.log

distclean: cleaner
	find . -name '*~' -print0 | xargs -0rt rm -f

spotless: distclean
	rm -rf configure config.h.in wraplinux.spec .depend

#
# Prepare a release
#
release:
	$(MAKE) depend
	$(MAKE) spec
	$(MAKE) distclean

#
# Autoconf
#
config:	MCONFIG

MCONFIG: configure MCONFIG.in config.h.in
	./configure

config.h: MCONFIG
	: Generated by side effect

config.h.in: configure.in
	rm -f config.h.in
	autoheader

configure: configure.in aclocal.m4
	autoconf
	rm -f MCONFIG config.cache config.log config.status config.h

#
# Version header
#
VERSION = $(shell cat version)

version.h: version
	echo "#define WRAPLINUX_VERSION \"$(VERSION)\"" > version.h

#
# RPM specfile
#
spec: wraplinux.spec

wraplinux.spec: wraplinux.spec.in version
	$(SED) -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@

#
# Dependencies
#
depend: .depend

.depend:
	: > $@
	$(PERL) mkdep.pl -M $@ -- . reloc highmove

-include .depend

=== debian/changelog ===
wraplinux (1.7-8) unstable; urgency=low

  * Adding dpkg-source local options.
  * Updating to standards version 3.9.4.
  * Fixing build to work twice in a row.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 11 Dec 2012 21:38:23 +0100

wraplinux (1.7-7) unstable; urgency=low

  * Using compression level 9 also for binary packages.
  * Updating copyright file to format version 1.0.
  * Updating to debhelper version 9.
  * Updating to standards version 3.9.3.
  * Switching to xz compression.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Sat, 30 Jun 2012 15:07:14 +0200

wraplinux (1.7-6) unstable; urgency=low

  * Correcting spelling mistake in 1.7-4 changelog entry.
  * Adding debug package.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Wed, 13 Jul 2011 01:33:04 +0200

wraplinux (1.7-5) unstable; urgency=low

  * Updating standards version to 3.9.2.
  * Compacting copyright file.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Sun, 10 Jul 2011 17:20:10 +0200

wraplinux (1.7-4) unstable; urgency=low

  * Updating maintainer and uploaders fields.
  * Removing vcs fields.
  * Removing references to my old email address.
  * Making packaging distribution neutral.
  * Updating year in copyright file.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Fri, 04 Feb 2011 21:10:24 +0100

wraplinux (1.7-3) unstable; urgency=low

  * Adding build-depends to gcc-multilib to fix FTBFS on amd64 (Closes:
    #608160).

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Tue, 28 Dec 2010 20:36:42 +0100

wraplinux (1.7-2) unstable; urgency=low

  * Switching to source format 3.0 (quilt).
  * Updating to debhelper version 8.
  * Simplyfing autotools handling in rules.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Sun, 26 Dec 2010 18:42:33 +0100

wraplinux (1.7-1) unstable; urgency=low

  * Updating package to standards version 3.8.3.
  * Adding maintainer homepage field to control.
  * Marking maintainer homepage field to be also included in binary
    packages and changelog.
  * Adding README.source.
  * Simplifying autotools handling in rules.
  * Adding explicit source version 1.0 until switch to 3.0.
  * Updating year in copyright file.
  * Updating to standards 3.8.4.
  * Moving maintainer homepage from control to copyright.
  * Bumping versioned build-depends on debhelper.
  * Updating README.source.
  * Restricting package to amd64 and i386 only.
  * Updating standards version to 3.9.0.
  * Merging upstream version 1.7.
  * Updating copyright file for new upstream.
  * Updating standards version to 3.9.1.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Wed, 01 Sep 2010 15:12:47 +0200

wraplinux (1.6-1) unstable; urgency=low

  * Initial release.

 -- Daniel Baumann <daniel.baumann@progress-technologies.net>  Fri, 07 Aug 2009 23:44:31 +0200

=== debian/control ===
Source: wraplinux
Section: utils
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-technologies.net>
Build-Depends: debhelper (>= 9), autotools-dev, gcc-multilib [amd64]
Standards-Version: 3.9.4
Homepage: http://ftp.kernel.org/pub/linux/utils/boot/wraplinux/

Package: wraplinux
Architecture: amd64 i386
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utility to wrap a Linux kernel and initrd into an ELF or NBI file
 wraplinux is a tool to wrap an x86 Linux kernel and one or more initrd files
 into asingle file in ELF or NBI format, as required by some booting protocols.

Package: wraplinux-dbg
Section: debug
Priority: extra
Architecture: amd64 i386
Depends: ${misc:Depends}, wraplinux (= ${binary:Version})
Description: Utility to wrap a Linux kernel and initrd into an ELF or NBI file (debug)
 wraplinux is a tool to wrap an x86 Linux kernel and one or more initrd files
 into asingle file in ELF or NBI format, as required by some booting protocols.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@} --with autotools_dev

override_dh_auto_clean:
	dh_auto_clean

	rm -f version.h

override_dh_auto_install:
	dh_auto_install -- INSTALLROOT=$(CURDIR)/debian/wraplinux

override_dh_strip:
	dh_strip --dbg-package=wraplinux-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz -z9
